<#--
 # MCreator (https://mcreator.net/)
 # Copyright (C) 2012-2020, Pylo
 # Copyright (C) 2020-2023, Pylo, opensource contributors
 #
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
 # the Free Software Foundation, either version 3 of the License, or
 # (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program.  If not, see <https://www.gnu.org/licenses/>.
 #
 # Additional permission for code generator templates (*.ftl files)
 #
 # As a special exception, you may create a larger work that contains part or
 # all of the MCreator code generator templates (*.ftl files) and distribute
 # that work under terms of your choice, so long as that work isn't itself a
 # template for code generation. Alternatively, if you modify or redistribute
 # the template itself, you may (at your option) remove this special exception,
 # which will cause the template and the resulting code generator output files
 # to be licensed under the GNU General Public License without this special
 # exception.
-->

<#-- @formatter:off -->
<#include "../procedures.java.ftl">

package ${package}.network;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD) public record ${name}ButtonMessage(int buttonID, int x, int y, int z, HashMap<String, String> textstate) implements CustomPacketPayload {

	public static final ResourceLocation ID = new ResourceLocation(${JavaModName}.MODID, "${registryname}_buttons");

	public ${name}ButtonMessage(FriendlyByteBuf buffer) {
		this(buffer.readInt(), buffer.readInt(), buffer.readInt(), buffer.readInt(), mapwork.readTextState(buffer));
	}

	@Override public void write(final FriendlyByteBuf buffer) {
		buffer.writeInt(buttonID);
		buffer.writeInt(x);
		buffer.writeInt(y);
		buffer.writeInt(z);
		mapwork.writeTextState(textstate, buffer);
	}
	
	public static class mapwork {

	  public static void writeTextState(HashMap<String, String> map, FriendlyByteBuf buffer) {
		buffer.writeInt(map.size());
		for (Map.Entry<String, String> entry : map.entrySet()) {
			buffer.writeComponent(Component.literal(entry.getKey()));  
                        buffer.writeComponent(Component.literal(entry.getValue())); 
		}
	  }

	  public static HashMap<String, String> readTextState(FriendlyByteBuf buffer) {
		int size = buffer.readInt(); 
		HashMap<String, String> map = new HashMap<>();
		for (int i = 0; i < size; i++) {
			String key = buffer.readComponent().getString();
                        String value = buffer.readComponent().getString();
			map.put(key, value);
		}
		return map;
	  }
	}

	@Override public ResourceLocation id() {
		return ID;
	}

	public static void handleData(final ${name}ButtonMessage message, final PlayPayloadContext context) {
		if (context.flow() == PacketFlow.SERVERBOUND) {
			context.workHandler().submitAsync(() -> {
				Player entity = context.player().get();
				int buttonID = message.buttonID;
				int x = message.x;
				int y = message.y;
				int z = message.z;
				HashMap<String, String> textstate = message.textstate;

				handleButtonAction(entity, buttonID, x, y, z, textstate);
			}).exceptionally(e -> {
				context.packetHandler().disconnect(Component.literal(e.getMessage()));
				return null;
			});
		}
	}

	public static void handleButtonAction(Player entity, int buttonID, int x, int y, int z, HashMap<String, String> textstate) {
		Level world = entity.level();
		HashMap guistate = ${name}Menu.guistate;
		for (Map.Entry<String, String> entry : textstate.entrySet()) {
        String key = entry.getKey();
        String value = entry.getValue();
        guistate.put(key, value);
        }

		// security measure to prevent arbitrary chunk generation
		if (!world.hasChunkAt(new BlockPos(x, y, z)))
			return;

		<#assign btid = 0>
                <#if hasProcedure(data.onTick)>
                if (buttonID == -1) {
		<@procedureOBJToCode data.onTick/>
                }
                </#if>
                <#if hasProcedure(data.onClosed)>
                if (buttonID == -2) {
                <@procedureOBJToCode data.onClosed/>
                }
                </#if>
		<#list data.getComponentsOfType("Button") as component>
				<#if hasProcedure(component.onClick)>
					if (buttonID == ${btid}) {
						<@procedureOBJToCode component.onClick/>
					}
				</#if>
				<#assign btid +=1>
		</#list>
		<#list data.getComponentsOfType("ImageButton") as component>
				<#if hasProcedure(component.onClick)>
					if (buttonID == ${btid}) {
						<@procedureOBJToCode component.onClick/>
					}
				</#if>
				<#assign btid +=1>
		</#list>
	}

	@SubscribeEvent public static void registerMessage(FMLCommonSetupEvent event) {
		${JavaModName}.addNetworkMessage(${name}ButtonMessage.ID, ${name}ButtonMessage::new, ${name}ButtonMessage::handleData);
	}
	

}
<#-- @formatter:on -->